package org.clank.support.aliases;

import org.clank.support.Converted;
import java.util.Iterator;
import static org.clank.support.Native.$tryClone;

/**
 * Implementation of java iterator over ${TYPE}. Used in iterable collections.
 */
//<editor-fold defaultstate="collapsed" desc="template">
@Converted(kind = Converted.Kind.DUMMY, source = "${SPUTNIK}/modules/org.clank.java/src/org/clank/support/aliases/templates/javaiterator.tpl")
//</editor-fold>
public final class ${FILE_NAME}${CLASS_SUFFIX} implements Iterator<${TYPE}> {

  private final ${NATIVE_ITERATOR} begin;
  private boolean preIncBegin = false;
  private final ${NATIVE_ITERATOR} end;

  public ${FILE_NAME}(${NATIVE_ITERATOR} begin, ${NATIVE_ITERATOR} end) {
    this.begin = $tryClone(begin);
    this.end = end;
  }

  @Override
  public boolean hasNext() {
    if (preIncBegin) {
      begin.$preInc();
      preIncBegin = false;
    }  
    return begin.$noteq(end);
  }

  @Override
  public ${TYPE} next() {
    if (preIncBegin) {
      begin.$preInc();
      preIncBegin = false;
    }  
    ${TYPE} val = begin.$star();
    preIncBegin = true;
    return val;
  }

  @Override
  public void remove() {
    throw new UnsupportedOperationException("Not supported.");
  }
}
