package org.clank.support.aliases;

import org.clank.support.Converted;
import org.clank.support.abstract_pointer;

/**
 * Pointer to ${TYPE}
 */
//<editor-fold defaultstate="collapsed" desc="template">
@Converted(kind = Converted.Kind.DUMMY, source = "${SPUTNIK}/modules/org.clank.java/src/org/clank/support/aliases/templates/pointerpointer.tpl")
//</editor-fold>
public interface ${FILE_NAME}${CLASS_SUFFIX} extends abstract_pointer<${FILE_NAME}${CLASS_SUFFIX}>, ${ITERATOR} {
    /**
      * Accessors for performance critical paths
      */
    int $index();
    ${TYPE}[] $array();

    /**
     * Gets value from pointer ('*x' in C++)
     * 
     * @return value
     */
    ${TYPE} $star();

    /**
     * Gets reference from pointer ('*x' passed to '&T')
     * 
     * @return reference to memory
     */
    ${REFERENCE} star$ref();
    
    /**
     * Replaces value in pointer ('*x = value' in C++)
     * 
     * @param value - new value
     * @return value
     */
    ${TYPE} $set(${TYPE} value);

    /**
     * Gets value from pointer at the given index ('x[10]' in C++)
     * 
     * @return value
     */        
    ${TYPE} $at(int index);
    default ${TYPE} $at(uint$ref index) { return $at(index.$deref()); }
    default ${TYPE} $at(int$ref index) { return $at(index.$deref()); }
    
    /**
     * Replaces value in pointer at the given index ('x[10] = value' in C++)
     * 
     * @param value - new value
     * @return value
     */
    ${TYPE} $set(int index, ${TYPE} value);
    default ${TYPE} $set(uint$ref index, ${TYPE} value) { return $set(index.$deref(), value); }
    default ${TYPE} $set(int$ref index, ${TYPE} value) { return $set(index.$deref(), value); }

    /**
     * modify value at the given index (i.e. 'x[10] += value' in C++)
     * 
     * @param value - value
     * @return value
     */${BUILTIN_TYPE_MODIFY_VALUE_SECTION_START}
    ${BUILTIN_TYPE_MODIFY_VALUE_SECTION_END}${ADDITIONAL_MODIFY_VALUE_SECTION_START}
    ${TYPE} $set$addassign(int index, ${TYPE} value); // "+=" 
    ${TYPE} $set$minusassign(int index, ${TYPE} value); // "-="
    ${TYPE} $set$starassign(int index, ${TYPE} value); // "*="    
    ${TYPE} $set$slashassign(int index, ${TYPE} value); // "/="
    ${TYPE} $set$postInc(int index); // "x++"    
    ${TYPE} $set$postDec(int index); // "x--"    
    ${TYPE} $set$preInc(int index); // "++x"    
    ${TYPE} $set$preDec(int index); // "--x"  
    ${ADDITIONAL_MODIFY_VALUE_SECTION_END}
}        