
package org.llvm.adt.aliases;

import org.llvm.adt.*;
import org.clank.support.Converted;

/**
 * Manually added class. Result of merge of ImutKeyValueInfo, ImutContainerInfo and ImutProfileInfo
 * 
 * @author petrk
 */
@Converted(kind = Converted.Kind.MANUAL_ADDED)
public interface ${FILE_NAME}${CLASS_SUFFIX} {
  
  /////////////////////////////////////////////////////////////////////////////
  // ImutKeyValueInfo & ImutContainerInfo
  
  //<editor-fold defaultstate="collapsed" desc="llvm::ImutContainerInfo::KeyOfValue">
  @Converted(kind = Converted.Kind.MANUAL_ADDED,
   source = "${LLVM_SRC}/llvm/include/llvm/ADT/ImmutableSet.h", line = 917,
   FQN="llvm::ImutContainerInfo::KeyOfValue", NM="_ZN4llvm17ImutContainerInfo10KeyOfValueENS_15ImutProfileInfoIT_E14value_type_refE",
   cmd="jclank.sh -java-options=${SPUTNIK}/modules/org.llvm.adtsupport/llvmToClangType ${LLVM_SRC}/llvm/tools/clang/lib/StaticAnalyzer/Core/CallEvent.cpp -nm=_ZN4llvm17ImutContainerInfo10KeyOfValueENS_15ImutProfileInfoIT_E14value_type_refE")
  //</editor-fold>
  ${KEY_TYPE} KeyOfValue(${VALUE_TYPE} D);

  //<editor-fold defaultstate="collapsed" desc="llvm::ImutContainerInfo::DataOfValue">
  @Converted(kind = Converted.Kind.MANUAL_ADDED,
   source = "${LLVM_SRC}/llvm/include/llvm/ADT/ImmutableSet.h", line = 918,
   FQN="llvm::ImutContainerInfo::DataOfValue", NM="_ZN4llvm17ImutContainerInfo11DataOfValueENS_15ImutProfileInfoIT_E14value_type_refE",
   cmd="jclank.sh -java-options=${SPUTNIK}/modules/org.llvm.adtsupport/llvmToClangType ${LLVM_SRC}/llvm/tools/clang/lib/StaticAnalyzer/Core/CallEvent.cpp -nm=_ZN4llvm17ImutContainerInfo11DataOfValueENS_15ImutProfileInfoIT_E14value_type_refE")
  //</editor-fold>
  ${DATA_TYPE} DataOfValue(${VALUE_TYPE} $Prm0);

  
  //<editor-fold defaultstate="collapsed" desc="llvm::ImutContainerInfo::isEqual">
  @Converted(kind = Converted.Kind.MANUAL_ADDED,
   source = "${LLVM_SRC}/llvm/include/llvm/ADT/ImmutableSet.h", line = 920,
   FQN="llvm::ImutContainerInfo::isEqual", NM="_ZN4llvm17ImutContainerInfo7isEqualENS_15ImutProfileInfoIT_E14value_type_refES4_",
   cmd="jclank.sh -java-options=${SPUTNIK}/modules/org.llvm.adtsupport/llvmToClangType ${LLVM_SRC}/llvm/tools/clang/lib/StaticAnalyzer/Core/CallEvent.cpp -nm=_ZN4llvm17ImutContainerInfo7isEqualENS_15ImutProfileInfoIT_E14value_type_refES4_")
  //</editor-fold>
  boolean isEqual(${KEY_TYPE} LHS, ${KEY_TYPE} RHS);
  
  //<editor-fold defaultstate="collapsed" desc="llvm::ImutContainerInfo::isLess">
  @Converted(kind = Converted.Kind.MANUAL_ADDED,
   source = "${LLVM_SRC}/llvm/include/llvm/ADT/ImmutableSet.h", line = 924,
   FQN="llvm::ImutContainerInfo::isLess", NM="_ZN4llvm17ImutContainerInfo6isLessENS_15ImutProfileInfoIT_E14value_type_refES4_",
   cmd="jclank.sh -java-options=${SPUTNIK}/modules/org.llvm.adtsupport/llvmToClangType ${LLVM_SRC}/llvm/tools/clang/lib/StaticAnalyzer/Core/CallEvent.cpp -nm=_ZN4llvm17ImutContainerInfo6isLessENS_15ImutProfileInfoIT_E14value_type_refES4_")
  //</editor-fold>
  boolean isLess(${KEY_TYPE} LHS, ${KEY_TYPE} RHS);

  
  //<editor-fold defaultstate="collapsed" desc="llvm::ImutContainerInfo::isDataEqual">
  @Converted(kind = Converted.Kind.MANUAL_ADDED,
   source = "${LLVM_SRC}/llvm/include/llvm/ADT/ImmutableSet.h", line = 928,
   FQN="llvm::ImutContainerInfo::isDataEqual", NM="_ZN4llvm17ImutContainerInfo11isDataEqualEbb",
   cmd="jclank.sh -java-options=${SPUTNIK}/modules/org.llvm.adtsupport/llvmToClangType ${LLVM_SRC}/llvm/tools/clang/lib/StaticAnalyzer/Core/CallEvent.cpp -nm=_ZN4llvm17ImutContainerInfo11isDataEqualEbb")
  //</editor-fold>
  boolean isDataEqual(${DATA_TYPE} $Prm0, ${DATA_TYPE} $Prm1);
  
  /////////////////////////////////////////////////////////////////////////////
  // ImutProfileInfo
  
  //<editor-fold defaultstate="collapsed" desc="llvm::ImutProfileInfo::Profile">
  @Converted(kind = Converted.Kind.MANUAL_ADDED,
   source = "${LLVM_SRC}/llvm/include/llvm/ADT/ImmutableSet.h", line = 841,
   FQN="llvm::ImutProfileInfo::Profile", NM="_ZN4llvm15ImutProfileInfo7ProfileERNS_16FoldingSetNodeIDERKT_",
   cmd="jclank.sh -java-options=${SPUTNIK}/modules/org.llvm.adtsupport/llvmToClangType ${LLVM_SRC}/llvm/tools/clang/lib/StaticAnalyzer/Core/CallEvent.cpp -nm=_ZN4llvm15ImutProfileInfo7ProfileERNS_16FoldingSetNodeIDERKT_")
  //</editor-fold>
  void Profile(final FoldingSetNodeID /*&*/ ID, final /*const*/ ${VALUE_TYPE} /*&*/ X);
}