
package org.llvm.adt.aliases;

import org.clank.java.*;
import org.clank.support.*;
import org.llvm.adt.*;


/// Generic iterator that wraps a T::TreeTy::iterator and exposes
/// iterator::getValue() on dereference.
/*template <typename T> TEMPLATE*/
//<editor-fold defaultstate="collapsed" desc="llvm::ImutAVLValueIterator">
@Converted(kind = Converted.Kind.MANUAL_SEMANTIC,
 source = "${LLVM_SRC}/llvm/include/llvm/ADT/ImmutableSet.h", line = 813,
 FQN="llvm::ImutAVLValueIterator", NM="_ZN4llvm20ImutAVLValueIteratorE",
 cmd="jclank.sh -java-options=${SPUTNIK}/modules/org.llvm.adtsupport/llvmToClangType ${LLVM_SRC}/llvm/tools/clang/lib/StaticAnalyzer/Core/CallEvent.cpp -nm=_ZN4llvm20ImutAVLValueIteratorE")
//</editor-fold>
public class/*struct*/ ${FILE_NAME}${CLASS_SUFFIX}  
        extends ${ADAPTOR_BASE} {
  //<editor-fold defaultstate="collapsed" desc="llvm::ImutAVLValueIterator::ImutAVLValueIterator<T>">
  @Converted(kind = Converted.Kind.AUTO,
   source = "${LLVM_SRC}/llvm/include/llvm/ADT/ImmutableSet.h", line = 820,
   FQN="llvm::ImutAVLValueIterator::ImutAVLValueIterator<T>", NM="_ZN4llvm20ImutAVLValueIteratorC1Ev",
   cmd="jclank.sh -java-options=${SPUTNIK}/modules/org.llvm.adtsupport/llvmToClangType ${LLVM_SRC}/llvm/tools/clang/lib/StaticAnalyzer/Core/CallEvent.cpp -nm=_ZN4llvm20ImutAVLValueIteratorC1Ev")
  //</editor-fold>
  public ${FILE_NAME}()/* = default*/ {
    super(new ${AVL_ORDERED_ITER_NAME}());
  }


  //<editor-fold defaultstate="collapsed" desc="llvm::ImutAVLValueIterator::ImutAVLValueIterator<T>">
  @Converted(kind = Converted.Kind.MANUAL_COMPILATION,
   source = "${LLVM_SRC}/llvm/include/llvm/ADT/ImmutableSet.h", line = 821,
   FQN="llvm::ImutAVLValueIterator::ImutAVLValueIterator<T>", NM="_ZN4llvm20ImutAVLValueIteratorC1EPNT_6TreeTyE",
   cmd="jclank.sh -java-options=${SPUTNIK}/modules/org.llvm.adtsupport/llvmToClangType ${LLVM_SRC}/llvm/tools/clang/lib/StaticAnalyzer/Core/CallEvent.cpp -nm=_ZN4llvm20ImutAVLValueIteratorC1EPNT_6TreeTyE")
  //</editor-fold>
  public /*explicit*/ ${FILE_NAME}( ${AVL_TREE_TYPE} /*P*/ Tree) {
    // : ImutAVLValueIterator<T>::iterator_adaptor_base(Tree) 
    //START JInit
    /*ParenListExpr*/super(new ${AVL_ORDERED_ITER_NAME}(Tree));
    //END JInit
  }
  
  @Converted(kind = Converted.Kind.MANUAL_ADDED)
  public ${FILE_NAME}(${CLASS_TYPE} Other) {
    super(new ${AVL_ORDERED_ITER_NAME}(Other.I));
  }
  
  //<editor-fold defaultstate="collapsed" desc="llvm::ImutAVLValueIterator::operator*">
  @Converted(kind = Converted.Kind.AUTO,
   source = "${LLVM_SRC}/llvm/include/llvm/ADT/ImmutableSet.h", line = 824,
   FQN="llvm::ImutAVLValueIterator::operator*", NM="_ZNK4llvm20ImutAVLValueIteratordeEv",
   cmd="jclank.sh -java-options=${SPUTNIK}/modules/org.llvm.adtsupport/llvmToClangType ${LLVM_SRC}/llvm/tools/clang/lib/StaticAnalyzer/Core/CallEvent.cpp -nm=_ZNK4llvm20ImutAVLValueIteratordeEv")
  //</editor-fold>
  public  ${VALUE_TYPE} $star() /*const*/ {
    return this.I.$arrow().getValue();
  }

  @Override
  public ${CLASS_TYPE} clone() {
    return new ${CLASS_TYPE}(this);
  }  

  @Override public String toString() {
    return "" + super.toString(); // NOI18N
  }
}
