
package org.llvm.adt.aliases;

import org.clank.support.*;

/*template <typename ValueTy> TEMPLATE*/

/// StringMapEntryInitializer - This datatype can be partially specialized for
/// various datatypes in a stringmap to allow them to be initialized when an
/// entry is default constructed for the map.
//<editor-fold defaultstate="collapsed" desc="llvm::StringMapEntryInitializer">
@Converted(kind = Converted.Kind.MANUAL, source = "${LLVM_SRC}/llvm/include/llvm/ADT/StringMap.h", line = 32,
 cmd = "jclank.sh -java-options=${SPUTNIK}/modules/org.llvm.adtsupport/llvmToClangType ${LLVM_SRC}/llvm/lib/Support/StringMap.cpp -filter=llvm::StringMapEntryInitializer")
//</editor-fold>
public class ${FILE_NAME}${CLASS_SUFFIX}  {
/*public:*/
  /*template <typename InitTy> TEMPLATE*/
  //<editor-fold defaultstate="collapsed" desc="llvm::StringMapEntryInitializer::Initialize">
  @Converted(kind = Converted.Kind.MANUAL, source = "${LLVM_SRC}/llvm/include/llvm/ADT/StringMap.h", line = 36,
   cmd = "jclank.sh -java-options=${SPUTNIK}/modules/org.llvm.adtsupport/llvmToClangType ${LLVM_SRC}/llvm/lib/Support/StringMap.cpp -filter=llvm::StringMapEntryInitializer::Initialize")
  //</editor-fold>
  public static ${INIT_PREFIX} void Initialize(${ENTRY} /*&*/ T, ${INIT_TYPE} InitVal) {
    T.second = InitVal;
  }

}
