package org.clank.java.stdimpl.aliases;

import org.clank.java.*;
import org.clank.support.*;
import org.clank.support.aliases.*;

//<editor-fold defaultstate="collapsed" desc="template">
@Converted(kind = Converted.Kind.DUMMY, source = "${SPUTNIK}/modules/org.clank.java/src/org/clank/support/aliases/templates/StdReverseIterator.tpl")
//</editor-fold>
public abstract class ${FILE_NAME}${CLASS_SUFFIX} implements ${INTERFACE_ITERATOR} {
    
    private ${VALUE_ITERATOR} delegate;

    public ${FILE_NAME}(${VALUE_ITERATOR} delegate) {
      this.delegate = Native.$tryClone(delegate);
    }

    public ${FILE_NAME}(JavaDifferentiators.JD$NoCloneInput _dparm, ${VALUE_ITERATOR} delegate) {
      this.delegate = delegate;
    }

    public ${FILE_NAME}(${FILE_NAME}${CLASS_SUFFIX} other) {
      this.delegate = Native.$tryClone(other.delegate);
    }
    
    @Override
    public ${VALUE_TYPE} $star() {
      ${VALUE_ITERATOR} tmp = delegate.clone();
      tmp.$preDec();
      return tmp.$star();
    }

    public ${STD_DUAL_ITERATOR} $assign(${STD_DUAL_ITERATOR} other) {
      throw new UnsupportedOperationException("Not supported.");
    }

    @Override
    public int $sub(${STD_DUAL_ITERATOR} iter) {
      // Subtract in reverse order: iter - this
      ${VALUE_ITERATOR_GENERIC} first = (${VALUE_ITERATOR_GENERIC}) this.delegate;
      ${VALUE_ITERATOR_GENERIC} last = (${VALUE_ITERATOR_GENERIC}) ((${FILE_NAME}) iter).delegate;
      return last.$sub(first);
    }

    @Override
    public ${STD_DUAL_ITERATOR} $preInc() {
      delegate.$preDec();
      return (${STD_DUAL_ITERATOR}) this;
    }

    @Override
    public ${STD_DUAL_ITERATOR} $preDec() {
      delegate.$preInc();
      return (${STD_DUAL_ITERATOR}) this;
    }

    @Override
    public ${STD_DUAL_ITERATOR} $postInc() {
      ${STD_DUAL_ITERATOR} cloned = clone();
      delegate.$preDec();
      return cloned;
    }

    @Override
    public ${STD_DUAL_ITERATOR} $postDec() {
      ${STD_DUAL_ITERATOR} cloned = clone();
      delegate.$preInc();
      return cloned;
    }

    @Override
    public ${STD_DUAL_ITERATOR} $inc(int amount) {
      delegate.$dec(amount);
      return (${STD_DUAL_ITERATOR}) this;
    }

    @Override
    public ${STD_DUAL_ITERATOR} $dec(int amount) {
      delegate.$inc(amount);
      return (${STD_DUAL_ITERATOR}) this;
    }

    @Override
    public ${STD_DUAL_ITERATOR} $add(int amount) {
      return new ${STD_DUAL_ITERATOR}(delegate.$sub(amount));
    }

    @Override
    public ${STD_DUAL_ITERATOR} $sub(int amount) {
      return new ${STD_DUAL_ITERATOR}(delegate.$add(amount));
    }

    @Override
    public boolean $noteq(Object other) {
      return other instanceof ${FILE_NAME} && delegate.$noteq(((${FILE_NAME}) other).delegate);
    }

    @Override
    public boolean $eq(Object other) {
      return other instanceof ${FILE_NAME} && delegate.$eq(((${FILE_NAME}) other).delegate);
    }

    @Override
    public ${STD_DUAL_ITERATOR} clone() {
      return new ${STD_DUAL_ITERATOR}(delegate.clone());
    }

    @Override
    public ${STD_DUAL_ITERATOR} const_clone() {
      return new ${STD_DUAL_ITERATOR}(delegate.const_clone());
    }

    @Override
    public ${VALUE_REFERENCE} star$ref() {
      return new ${VALUE_REFERENCE}() {

        ${VALUE_ITERATOR} localIter = delegate.clone();

        @Override
        public ${VALUE_TYPE} $deref() {
          return localIter.$star();
        }

        @Override
        public ${VALUE_TYPE} $set(${VALUE_TYPE} value) {
          return localIter.star$ref().$set(value);
        }

        @Override
        public ${VALUE_POINTER} deref$ptr() {
          return localIter.star$ref().deref$ptr();
        }
      };
    }    

    public ${VALUE_ITERATOR} base() {
      return delegate.clone();
    }
  }
