package org.clank.support.aliases;

import org.clank.support.Converted;
import org.clank.support.Native;

/**
 * Reference to ${TYPE}
 */
//<editor-fold defaultstate="collapsed" desc="template">
@Converted(kind = Converted.Kind.DUMMY, source = "${SPUTNIK}/modules/org.clank.java/src/org/clank/support/aliases/templates/reference.tpl")
//</editor-fold>
public interface ${FILE_NAME}${CLASS_SUFFIX} extends Native.Native$Bool {

  ${TYPE} $deref();
  
  ${TYPE} $set(${TYPE} value);
  ${BUILTIN_TYPE_MODIFY_VALUE_SECTION_START}
  default ${TYPE} $assign(${TYPE} value) { return $set(value); }
  ${BUILTIN_TYPE_MODIFY_VALUE_SECTION_END}
  default ${POINTER} deref$ptr() { throw new UnsupportedOperationException(); }

  ${BUILTIN_TYPE_MODIFY_VALUE_SECTION_START}
  default ${TYPE} $set$andassign(${TYPE} value) { // "&="
    ${TYPE} newVal = (${TYPE})($deref() & value);
    return $set(newVal);
  }
  default ${TYPE} $set$xorassign(${TYPE} value) { // "^="
    ${TYPE} newVal = (${TYPE})($deref() ^ value);
    return $set(newVal);
  }
  default ${TYPE} $set$orassign(${TYPE} value) { // "|=" 
    ${TYPE} newVal = (${TYPE})($deref() | value);
    return $set(newVal);
  }
  ${BUILTIN_TYPE_MODIFY_VALUE_SECTION_END}${ADDITIONAL_MODIFY_VALUE_SECTION_START}
  default ${TYPE} $set$addassign(${TYPE} value) {// "+=" 
    ${TYPE} newVal = (${TYPE})($deref() + value);
    return $set(newVal);
  }
  default ${TYPE} $set$minusassign(${TYPE} value) {// "-="
    ${TYPE} newVal = (${TYPE})($deref() - value);
    return $set(newVal);
  }
  default ${TYPE} $set$starassign(${TYPE} value) {// "*="    
    ${TYPE} newVal = (${TYPE})($deref() * value);
    return $set(newVal);
  }
  default ${TYPE} $set$slashassign(${TYPE} value) {// "/="
    ${TYPE} newVal = (${TYPE})($deref() / value);
    return $set(newVal);
  }
  default ${TYPE} $set$modassign(${TYPE} value) {// "%=" 
    ${TYPE} newVal = (${TYPE})($deref() % value);
    return $set(newVal);
  }
  default ${TYPE} $set$lshiftassign(${TYPE} value) {// "<<="
    ${TYPE} newVal = (${TYPE})($deref() << value);
    return $set(newVal);
  }
  default ${TYPE} $set$rshiftassign(${TYPE} value) {// ">>="
    ${TYPE} newVal = (${TYPE})($deref() ${RSHIFT_OP} value);
    return $set(newVal);
  }
  default ${TYPE} $set$postInc() {// "x++"
    ${TYPE} oldVal = $deref();
    $set((${TYPE})(oldVal+1));
    return oldVal;
  }    
  default ${TYPE} $set$postDec() {// "x--"    
    ${TYPE} oldVal = $deref();
    $set((${TYPE})(oldVal-1));
    return oldVal;
  }    
  default ${TYPE} $set$preInc() {// "++x"    
    ${TYPE} newVal = (${TYPE})($deref() + 1);
    return $set(newVal);
  }
  default ${TYPE} $set$preDec() {// "--x"  
    ${TYPE} newVal = (${TYPE})($deref() - 1);
    return $set(newVal);
  }
  ${ADDITIONAL_MODIFY_VALUE_SECTION_END}
}