package org.clank.support.aliases;

import org.clank.support.Converted;
import static org.clank.support.NativeType.${SIZEOF_VALUE};


/**
 * Implementation of memory of ${TYPE} local fields.
 */
//<editor-fold defaultstate="collapsed" desc="template">
@Converted(kind = Converted.Kind.DUMMY, source = "${SPUTNIK}/modules/org.clank.java/src/org/clank/support/aliases/templates/varmemimpl.tpl")
//</editor-fold>
public abstract class ${FILE_NAME} implements ${MEMORY_NAME} {
    
    public abstract ${TYPE} get();
    
    public abstract void set(${TYPE} value);

    @Override
    public ${TYPE} $at(/*uint*/int index) {
        if (index != 0) {
            throw new IllegalArgumentException("Index must be zero to access to the single variable!");
        }
        return get();
    }

    @Override
    public ${TYPE} $set(/*uint*/int index, ${TYPE} value) {
        if (index != 0) {
            throw new IllegalArgumentException("Index must be zero to access to the single variable!");
        }
        ${TYPE} oldValue = get();
        set(value);
        return oldValue;
    }

    @Override
    public int sizeof() {
      return ${SIZEOF_VALUE};
    }
    
    @Override
    public int size() {
        return 1;
    }  
    
    @Override
    public /*uint*/int toByteIndex(/*uint*/int index) {
        return index * sizeof();
    }

    @Override
    public /*uint*/int fromByteIndex(/*uint*/int index) {
        return index / sizeof();
    }        
}