package org.llvm.adt.aliases;

import org.clank.support.Converted;
import org.clank.support.*;
import org.clank.support.aliases.*;
import org.clank.support.JavaDifferentiators.*;

/**
 * SmallVector for ${TYPE}
 */
//<editor-fold defaultstate="collapsed" desc="template">
@Converted(kind = Converted.Kind.DUMMY, source = "${SPUTNIK}/modules/org.llvm.adtsupport/src/org/llvm/adt/aliases/templates/SmallVector.tpl")
//</editor-fold>
public class ${FILE_NAME}${CLASS_SUFFIX} extends ${SMALL_VECTOR_IMPL} 
 implements NativeCloneable<${FILE_NAME}${CLASS_SUFFIX}>, 
            NativeMoveable<${FILE_NAME}${CLASS_SUFFIX}>,
            Destructors.ClassWithDestructor {
  
  public ${FILE_NAME}(int capacity) {
    super(capacity, (${TYPE}) ${DEFAULT_VALUE});
  }

  public ${FILE_NAME}(int capacity, ${TYPE} defaultValue) {
    super(capacity, defaultValue);
  }
  
  public ${FILE_NAME}(int capacity, int initialSize, ${TYPE} defaultValue) {
    super(capacity, initialSize, defaultValue);
  }    

  public ${FILE_NAME}(JD$UInt_T$C$R _dparam, int capacity, int initialSize, ${TYPE} defaultValue) {
    super(_dparam, capacity, initialSize, defaultValue, defaultValue);
  }

  public ${FILE_NAME}(JD$UInt_T$C$R _dparam, int capacity, int initialSize, ${TYPE} value, ${TYPE} defaultValue) {
    super(_dparam, capacity, initialSize, value, defaultValue);
  }

  public ${FILE_NAME}(int capacity, ${TYPE} array[], ${TYPE} defaultValue) {
    super(array, defaultValue);
  }

  public ${FILE_NAME}(int capacity, ${ITERATOR_TYPE} iter, int length) {
    super(capacity, (${BASE_ITERATOR_TYPE})iter, length, (${TYPE}) ${DEFAULT_VALUE});
  }

  public ${FILE_NAME}(int capacity, ${ITERATOR_TYPE} iter, int length, ${TYPE} defaultValue) {
    super(capacity, (${BASE_ITERATOR_TYPE})iter, length, defaultValue);
  }

  public ${FILE_NAME}(int capacity, ${ITERATOR_TYPE} begin, ${ITERATOR_TYPE} end) {
    super(capacity, (${BASE_ITERATOR_TYPE})begin, (${BASE_ITERATOR_TYPE})end, (${TYPE}) ${DEFAULT_VALUE});
  }

  public ${FILE_NAME}(int capacity, ${ITERATOR_TYPE} begin, ${ITERATOR_TYPE} end, ${TYPE} defaultValue) {
    super(capacity, (${BASE_ITERATOR_TYPE})begin, (${BASE_ITERATOR_TYPE})end, defaultValue);
  }

  public ${FILE_NAME}(JD$T _dparam, int capacity, ${ITERATOR_TYPE} begin, ${ITERATOR_TYPE} end, ${TYPE} defaultValue) {
    super(capacity, (${BASE_ITERATOR_TYPE})begin, (${BASE_ITERATOR_TYPE})end, defaultValue);
  }
  // ${CUNSTRUCTOR_WITH_CONVERTER}

//  public ${FILE_NAME}(int capacity, ${ITERATOR_RANGE} range, ${TYPE} defaultValue) {
//    super(capacity, begin, end, defaultValue);
//  }

  public ${FILE_NAME}(${FILE_NAME}${CLASS_SUFFIX} other) {
    super(other);
  }

  public ${FILE_NAME}(JD$Move _dparam, ${FILE_NAME}${CLASS_SUFFIX} other) {
    super(_dparam, other);
  }

  @Override
  public ${FILE_NAME}${CLASS_SUFFIX} clone() {
    ${FILE_NAME}${CLASS_SUFFIX} out = new ${FILE_NAME}${CLASS_SUFFIX}(this);
    assert this.getClass() == out.getClass() : "forgot to override clone in " + out.getClass();
    return out;
  }

  @Override
  public ${FILE_NAME}${CLASS_SUFFIX} move() {
    ${FILE_NAME}${CLASS_SUFFIX} out = new ${FILE_NAME}${CLASS_SUFFIX}(JD$Move.INSTANCE, this);
    assert this.getClass() == out.getClass() : "forgot to override move in " + out.getClass();
    return out;
  }

  public void insert_iterator$T_T$C$R(${ITERATOR_TYPE} I, ${TYPE} LocDecl) {
    throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
  }
  
  //${DOWNCASTINSERT}
}
